unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, nUsbDevice, ImgList;

type
  TMainForm = class(TForm)
    Label1: TLabel;
    UsbList: TListView;
    ImageList: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure UsbListDblClick(Sender: TObject);
  private
    { Private 錾 }
    procedure SetUsbList;
  public
    { Public 錾 }
    procedure WMDeviceChange(var Msg: TMessage); message WM_DEVICECHANGE;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

procedure TMainForm.SetUsbList;
var
  no, count: Integer;
  li: TListItem;
  name: array [0..255] of Char;
  description: array [0..255] of Char;
begin
  UsbList.Items.Clear;
  count := NUsbGetDeviceData(0);
  ImageList.Handle := NUsbGetImageListHandle;
  for no := 0 to count - 1 do
  begin
    NUsbGetFriendlyName(no, name, 256);
    NUsbGetDescription(no, description, 256);
    li := UsbList.Items.Add;
    if name[0] = #0 then
      li.Caption := StrPas(description)
    else
      li.Caption := StrPas(name);
    NUsbGetDeviceId(no, name, 256);
    li.SubItems.Add(StrPas(name));
    li.SubItems.Add(StrPas(description));
    NUsbGetManufacturerName(no, name, 256);
    li.SubItems.Add(StrPas(name));
    NUsbGetDriveLetter(no, name, 256);
    li.SubItems.Add(StrPas(name));
    if NUsbCheckRemovableNo(no) then
      li.SubItems.Add('');
    li.Data := Pointer(NUsbGetDeviceHandle(no));
    li.ImageIndex := NUsbGetImageListIndex(no);
  end;
  NUsbReleaseDeviceData;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  w: Integer;
begin
  w := (UsbList.ClientWidth - GetSystemMetrics(SM_CXVSCROLL)) div 9;
  UsbList.Columns[0].Width := W * 2;
  UsbList.Columns[1].Width := W * 2;
  UsbList.Columns[2].Width := W * 2;
  UsbList.Columns[3].Width := W;
  UsbList.Columns[4].Width := W;
  UsbList.Columns[5].Width := W;

  SetUsbList;
end;

procedure TMainForm.WMDeviceChange(var Msg: TMessage);
begin
  SetUsbList;
end;

procedure TMainForm.UsbListDblClick(Sender: TObject);
begin
  if UsbList.SelCount > 0 then
    NUsbEjectDeviceHandle(Integer(UsbList.Selected.Data));
end;

end.
